function  [pc_out,nei_results] = Denoising_Guided(Par,model,str,pc_noisy,filename_noise)
pc_out = pc_noisy;
Par.count = pc_out.Count;
Par.dim = Par.ne_num*Par.ch;  %ÿά
nei_results = [];
for ite = 1 : Par.IteNum
    % search non-local patch groups
    [nDCnlX,blk_arr,DC,Par,dis_near_number] = PointCloud2PG( pc_out, Par);
    %[nDCnlX,blk_arr,DC,Par,dis_near_number] = PointCloud2PG_SP( im_out, Par);%spin imageıȽϷ
    % Gaussian dictionary selection by MAP
    if mod(ite-1,2) == 0
        %% GMM: full posterior calculation
        nPG = size(nDCnlX,2)/Par.nlsp; % number of PGs
        PYZ = zeros(model.nmodels,nPG);
        for i = 1:model.nmodels
            sigma = model.covs(:,:,i);
            [R,~] = chol(sigma);
            Q = R'\nDCnlX;
            TempPYZ = - sum(log(diag(R))) - dot(Q,Q,1)/2;
            TempPYZ = reshape(TempPYZ,[Par.nlsp nPG]);
            PYZ(i,:) = sum(TempPYZ);
        end
        %% find the most likely component for each patch group
        [~,dicidx] = max(PYZ);%dicidxʾÿĸ˹
        dicidx=repmat(dicidx, [Par.nlsp 1]);
        dicidx = dicidx(:);%һ
        [idx,  s_idx] = sort(dicidx);
        idx2 = idx(1:end-1) - idx(2:end);%idxǰͬΪ0ͬΪ-1Ѱҷֽ
        seq = find(idx2);
        seg = [0; seq; length(dicidx)];
    end
    % Weighted Sparse Coding
    Y_hat = zeros(Par.dim,Par.count,'double');
    W_hat = zeros(Par.dim,Par.count,'double');
    
    for   j = 1:length(seg)-1
        idx =   s_idx(seg(j)+1:seg(j+1));
        cls =   dicidx(idx(1));%
        Y = nDCnlX(:,idx);
        De = Par.D{cls};
        b = De'*Y;
        De = De(:,1:Par.En);
        Se = Par.S{cls};
        lambdae = repmat(Par.c1./ (sqrt(Se)+eps),[1 length(idx)]);%ݿһ壬Ƴ1lengthidx
        % soft threshold
        alpha = sign(b).*max(abs(b)-lambdae,0);%Ϊʲôlambdaeûг2
        alphai = alpha(Par.En+1:end,:);
        [U,~,V] = svd((eye(size(Y,1))-De*De')*Y*alphai','econ');
        Di = U*V';
        % lambdai = repmat(Par.c2./ (sqrt(Se)+eps),[1 length(idx)]);
        Dnew = [De Di];
        bnew = Dnew'*Y;
        % soft threshold
        alphanew = sign(bnew).*max(abs(bnew)-lambdae,0);
        % add DC components and aggregation
        Y_hat(:,blk_arr(:,idx)) = Y_hat(:,blk_arr(:,idx)) + bsxfun(@plus, Dnew*alphanew, DC(:,idx)); % not DC(:,blk_arr(:,idx))
        W_hat(:,blk_arr(:,idx)) = W_hat(:,blk_arr(:,idx)) + ones(Par.dim, length(idx));
    end
    % Reconstruction
    [pc_out,~,nei_results] = PGs2Normals(Y_hat,W_hat,Par,dis_near_number,nei_results,str,pc_noisy,filename_noise,ite);
end
% for t=1:1:size(SNRn,2)%ʾһ
%      plot(t,SNRn(t),'o-'); drawnow;
%      hold on
% end
% im_out(im_out > 1) = 1;
% im_out(im_out < 0) = 0;
return;
