clear;
t0 = clock;
TD_path = '10_PLY_normal' ;%'.\PCD_model_6_normal';
% Set the parameters
delta = 0.08;
win = 100;
ne_num = 10;      %С
nlsp = 10;        %Ŀ
cls_num  = 32;   %Ŀ
model.cls_num  = 32; %Ŀ
model.iter = 20;
% read natural point cloud

fpath       =   fullfile(TD_path, '*.ply');
im_dir      =   dir(fpath);
im_num      =   length(im_dir);
X           =  [];
X0          =  [];
for  i  =  1:im_num
    cloud_ptr = pcread(fullfile(TD_path, im_dir(i).name));
    [Px, Px0] = Get_PG(cloud_ptr,win, ne_num ,nlsp,delta);
    clear cloud_ptr;
    X0 = [X0 Px0];%X0ǳ
    X   = [X Px];%Xرƣ  
end

% PG-GMM Training
[model,ll_D,label] = Gmm(data,model,nlsp);
[s_idx, seg]    =  Proc_cls_idx( label );
cls_num = model.nmodels+1;
%model.R = []; % R is now useless
model.means(:,cls_num) = mean(X0,2);
model.covs(:,:,cls_num) = cov(X0');
length0 = size(X0,2)/nlsp;
model.mixweights = [model.mixweights length0/(length0 + length(label))]/(sum(model.mixweights) + length0/(length0 + length(label)));
model.nmodels = model.nmodels + 1;
for  i  =  1 : length(seg)-1
    idx    =   s_idx(seg(i)+1:seg(i+1));
    cls    =   label(idx(1));
    [P,S,~] = svd(model.covs(:,:,i));
    S = diag(S);
    GMM.D{cls}    =  P;
    GMM.S{cls}    =  S;
    Xc{cls} = data(:, idx);
end
[P0,S0,~] = svd(model.covs(:,:,cls_num));
S0 = diag(S0);
GMM.D{cls_num}    =  P0;
GMM.S{cls_num}    =  S0;
X0 = X0(:,randi(size(X0,2), [1 5e4]));%X0ѡ5e4
Xc{cls_num} = X0;
% save PG-GMM model
modelname = sprintf('point_cloud_npc_%dx_win%d_nlsp%d_delta%2.3f_cls%d.mat',ne_num,win,nlsp,delta,cls_num);
save(modelname,'model','nlsp','GMM','cls_num','delta','win','ne_num','-v7.3');
tn = clock;
etime(tn,t0)