function [ knns, noncomputeCount, nFeature ] = normalEstimatePatchShift( Pts, ptr, knnNei, knnPatch, neiBuildMethod )
 %Debug = 1;
if nargin == 2
    knnNei = 30;%30;
    knnPatch = 30;%30;
    neiBuildMethod = 2;
elseif nargin == 3
    knnPatch = 30;
    neiBuildMethod = 2;
elseif nargin == 4 
    neiBuildMethod = 2;
end
originalPath = cd;
path = which('normalEstimatePatchShift');
cd(path(1:end - 26 ));
addpath ('./toolbox/jjcao_io')
addpath ('./toolbox/jjcao_point')
addpath ('./toolbox/jjcao_common')
addpath ('./toolbox/jjcao_interact')
if ~ exist('kdtree_build.mexw32','file')
    addpath ('./toolbox/kdtree')
end
addpath ('./toolbox/jjcao_plot')

addpath('./toolbox/zj_fitting')
addpath('./toolbox/zj_deviation')
addpath('./RANSAC_Toolbox_master');
addpath('./toolbox/cvx')
addpath('./sources')
cvx_setup
cvx_setup

global TP;
global neigh_matrix;
global P;
global idFeatures;
%% tunable arguments
TP.debug_data = 0;
TP.debug_taproot = 0 ;
Debug.showKnn = 0;
Debug.plotResult = 1;
% argunments in feature extraction
TP.k_knn_feature = 80; %ʼsigmaʼ
TP.k_knn_normals = 30;%ˣû
TP.k_knn  = 120;%ûõ
TP.sigma_threshold = 0.05;%ԭʼֵ0.05
% argunments in neighborhood building
TP.knnNei  = knnNei;
TP.knnPatch = knnPatch;
TP.ran_num = 100 ;
TP.neiBuildMethod = neiBuildMethod;
TP.ptr = ptr;
P.pts = Pts;

P.kdtree = 0; %kdtree_build(P.pts);%ûkdtreeõԴ
TP.nSample = size(P.pts,1);
nSample = TP.nSample;

bbox = [min(P.pts(:,1)), min(P.pts(:,2)), min(P.pts(:,3)), max(P.pts(:,1)), max(P.pts(:,2)), max(P.pts(:,3))];%XYZֵСֵ
bx = bbox(4)-bbox(1);by = bbox(5)-bbox(2);bz = bbox(6)-bbox(3);
rs = bbox(4:6)-bbox(1:3);%ֵȥСֵ
diameter = sqrt(dot(rs,rs));%ģͺеĶԽ߳ȣ
%% construct neighboor matrix
feature_normal_r = 0.042 * diameter ;%0.042?,ûõ
neigh_matrix = zeros(TP.nSample, TP.knnNei);
for  i = 1 : TP.nSample
    neis = findNearestNeighbors(ptr,P.pts(i,:),TP.knnNei);%kdtree_k_nearest_neighbors(P.kdtree, P.pts(i,:), TP.knnNei);
    neigh_matrix(i,:) = neis;
end
%% show the density
TP.density = computeDensity(30);%ܶȣľƽõ
TP.area_w = TP.density .^ 2 ;%ܶƽʲô˼

%% compute initial features (a ribbon)
[sigms , normVectors , errs , normals_comW] = compute_points_sigms_normals_two(P.pts, TP.k_knn_feature, P.kdtree, TP.k_knn_normals);
%sigmanormVectorsõk_knn_featureĴСƽPCAúġk_knn_featureСӰƽ
TP.feature_threshold = feature_threshold_selection(sigms,TP);
idFeatures = find(sigms > TP.feature_threshold);
nFeature = length(idFeatures); %
TP.nFeature = length(idFeatures);
TP.featureSign = zeros(TP.nSample,1);
TP.featureSign(idFeatures) = 1;
noncompute_count = 0;

%% compute knns
[~, knns, noncomputeCount] = cmptNormal(Debug);%õTP.knnNei,СΪʼҲõTP.knnPatchΪѡһС
%kdtree_delete(P.kdtree);

% for i = 1:length(idFeatures)
%     normVectors(idFeatures(i),:) = normals(idFeatures(i),:);
% end
% normals = normVectors;
cd(originalPath);
end

